Attribute VB_Name = "SharedVar"
Option Explicit

'true if mouse if down on tileset/map/radar
Global mousedown As Boolean

Global bDEBUG As Boolean

Global Const TileW = 16
Global Const TileH = 16

Global tick As Long

Global clipdata() As Integer
Global clipBoundaries As RECT
Global clipBitField() As Boolean
Global clipHasData As Boolean

Type RECT
    Left As Integer
    Right As Integer
    Top As Integer
    Bottom As Integer
End Type

Enum toolenum
    T_magnifier = 1
    T_selection
    T_magicwand
    T_hand
    T_pencil
    T_dropper
    T_Eraser
    T_airbrush
    T_bucket
    T_line
    T_spline
    T_rectangle
    T_ellipse
    T_filledrectangle
    T_filledellipse
End Enum

Global splineInProgress As Boolean
Global curtool As toolenum

Function TilePixelColor(tileval As Integer) As Long
    Select Case tileval
    Case 0 'empty
      TilePixelColor = vbBlack
    Case -1 ' special case, for bigger special tiles
      TilePixelColor = vbMagenta
    Case 1 To 161 'normal
      TilePixelColor = RGB(192, 192, 192)
    Case 162 To 165 'Vdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 166 To 169 'Hdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 170 'flag
      TilePixelColor = vbYellow
    Case 171 'safe
      TilePixelColor = vbGreen
    Case 172 'soccer
      TilePixelColor = vbRed
    Case 173 To 175 'flyover
      TilePixelColor = vbCyan
    Case 176 To 183 'flyunderopaque
      TilePixelColor = vbCyan
    Case 184 To 190 'flyundertransparent
      TilePixelColor = vbCyan
    Case 191 To 215
      TilePixelColor = vbMagenta
    Case 216 'sasteroid1
      TilePixelColor = vbMagenta
    Case 217 'lasteroid
      TilePixelColor = vbMagenta
    Case 218 'sasteroid2
      TilePixelColor = vbMagenta
    Case 219 'starport
      TilePixelColor = vbMagenta
    Case 220 'wormhole
      TilePixelColor = vbMagenta
    Case 221 To 255
      TilePixelColor = vbMagenta
    Case Else 'invalid
      TilePixelColor = vbBlack
  End Select
End Function

Function isTileSpecial(map As frmMain, X As Integer, Y As Integer)
    If Not (X < 0 Or Y < 0 Or X > 1023 Or Y > 1023) Then
        If map.getTile(X, Y) <> 217 And map.getTile(X, Y) <> 219 And _
           map.getTile(X, Y) <> 220 And map.getTile(X, Y) <> -1 Then
            isTileSpecial = False
        Else
            isTileSpecial = True
        End If
    End If
End Function

Function isSelTileSpecial(sel As Selection, X As Integer, Y As Integer)
    If Not (X < 0 Or Y < 0 Or X > 1023 Or Y > 1023) Then
        If sel.getSelTile(X, Y) <> 217 And sel.getSelTile(X, Y) <> 219 And _
           sel.getSelTile(X, Y) <> 220 And sel.getSelTile(X, Y) <> -1 Then
            isSelTileSpecial = False
        Else
            isSelTileSpecial = True
        End If
    End If
End Function

Function GetRED(ByVal RGBColor As Long) As Long
GetRED = RGBColor And &HFF&
End Function

'get the green value from a long
Function GetGREEN(ByVal RGBColor As Long) As Long
GetGREEN = (RGBColor And &HFF00&) \ &H100&
End Function

'get the blue value from a long
Function GetBLUE(ByVal RGBColor As Long) As Long
GetBLUE = (RGBColor And &HFF0000) \ &H10000
End Function

