Attribute VB_Name = "SubClassing"
Option Explicit

Type POINTAPI
  X As Long
  Y As Long
End Type

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Const WM_MOUSEWHEEL As Long = &H20A
Private Const WM_DESTROY = &H2
Private Const GWL_WNDPROC = -4
Private lpPrevWndProc As Long

Sub Hook(ByVal gHW As Long)
    If bDEBUG Then Exit Sub
    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
    
Sub UnHook(ByVal gHW As Long)
    If bDEBUG Then Exit Sub
    If lpPrevWndProc Then
        SetWindowLong gHW, GWL_WNDPROC, lpPrevWndProc
        lpPrevWndProc = 0
    End If
End Sub
    
Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim zDelta As Long
  Select Case uMsg
    Case WM_DESTROY
      UnHook hWnd
      
    Case WM_MOUSEWHEEL
        zDelta = (wParam \ 65535) Mod 65535
        If zDelta < 0 Then
            Call frmGeneral.ExecuteZoom(False)
            'Call frmMain.ZoomIn((Int(((frmMain.hScr.value + frmMain.picpreview.Width / 2)) / (TileW * Zoom))), (Int(((frmMain.vscr.value + frmMain.picpreview.Height / 2)) / (TileH * Zoom))))
        Else
            Call frmGeneral.ExecuteZoom(True)
            'Call frmMain.ZoomOut((Int(((frmMain.hScr.value + frmMain.picpreview.Width / 2)) / (TileW * Zoom))), (Int(((frmMain.vscr.value + frmMain.picpreview.Height / 2)) / (TileH * Zoom))))
        End If
        
    Case WM_DCME_OPENMAP 'user-defined
        'wparam contains the pointer to the string we need
        'Dim path As String
        'path = PointerToString(wParam)
        
        If Dir$(App.path & "\paths") = "" Then
            Exit Function
        End If
        
        Dim f As Integer
        f = FreeFile

        Open App.path & "\paths" For Input As #f
            Dim str As String
            Line Input #f, str

            Dim res As Integer
            On Local Error Resume Next
            frmGeneral.SetFocus
            
            res = frmGeneral.OpenMap(str)
            If res = -1 Then
                Close #f
                Exit Function
            End If
        Close #f
        
        Kill App.path & "\paths"
        
        'Call PostMessage(lParam, &H10, 0, 0)
    Case Else
      WindowProc = CallWindowProc(lpPrevWndProc, hWnd, uMsg, wParam, lParam)
  End Select
End Function
